#ifndef BONEH
#define BONEH

#include <d3dx9.h>
#include <Coef.h>

class CMQOFace;
class CInfScope;

class CBone
{
public:
	CBone();
	~CBone();

	int SetBoneTri( CMQOFace* srcface, D3DXVECTOR3* srcpoint );
	int AddChild( CBone* childptr );

	static int ResetBoneCnt();

	int AddInfScope( CInfScope* pinfscope );
	int CalcTargetCenter();

private:
	int InitParams();
	int DestroyObjs();

public:
	int m_boneno;
	int m_topboneflag;
	char m_bonename[256];
	int m_bonematerialno;
	D3DXVECTOR3 m_vertpos[BT_MAX];
	CMQOFace* m_faceptr;


	int m_isnum;
	CInfScope* m_isarray[ INFSCOPEMAX ];


	CBone* m_parent;
	CBone* m_child;
	CBone* m_brother;


};

#endif