#ifndef INFSCOPEH
#define INFSCOPEH

#include <coef.h>
#include <d3dx9.h>

class CMQOObject;
class CMQOFace;
class CMQOMaterial;

class CInfScope
{
public:
	CInfScope();
	~CInfScope();

	int CalcCenter();
	int CheckInCnt( D3DXVECTOR3* vptr, int* incntptr, int* justptr );

private:
	int InitParams();
	int DestroyObjs();

	int ChkRay( int i1, int i2, int i3, D3DXVECTOR3* vptr, int* justptr );

public:
	int m_serialno;
	int m_materialno;
	int m_validflag;

	int m_facenum;
	CMQOFace** m_ppface;

	int m_vnum;
	D3DXVECTOR3* m_pvert;

	int m_applyboneno;
	CMQOObject* m_targetobj;

	D3DXVECTOR3 m_minv;
	D3DXVECTOR3 m_maxv;
	D3DXVECTOR3 m_center;

	int m_settminmax;
	D3DXVECTOR3 m_tminv;
	D3DXVECTOR3 m_tmaxv;
	D3DXVECTOR3 m_tcenter;
	float m_tmaxdist;

};

#endif