#ifndef MODELH
#define MODELH

#include <d3dx9.h>
#include <wchar.h>
#include <Coef.h>
#include <string>
#include <map>

using namespace std;


class CMQOMaterial;
class CMQOObject;
class CMQOFace;
class CBone;
class CInfScope;

class CModel
{
public:
	CModel();
	~CModel();

	int LoadMQO( LPDIRECT3DDEVICE9 pdev, WCHAR* wfile );
	int OnRender();
	int GetModelBound( MODELBOUND* dstb );

	int MakeObjectName();
	int MakeBoneTri();
	int MakeInfScope();

	int CalcInf();

	int DbgDump();

private:
	int InitParams();
	int DestroyObjs();
	int CreateMaterialTexture();

	int AddModelBound( MODELBOUND* mb, MODELBOUND* addmb );

	int DestroyMaterial();
	int DestroyObject();
	int DestroyAncObj();

	void MakeBoneReq( CBone* parbone, CMQOFace* curface, D3DXVECTOR3* pointptr, int broflag, int* errcntptr );

	int SetShapeNoReq( CMQOFace** ppface, int facenum, int searchp, int shapeno, int* setfacenum);
	int SetFaceOfShape( CMQOFace** ppface, int facenum, int shapeno, CMQOFace** ppface2, int setfacenum );

	int DbgDumpBoneReq( CBone* boneptr, int broflag );

public:
	int m_modelno;
	LPDIRECT3DDEVICE9 m_pdev;

	map<int, CMQOMaterial*> m_material;
	map<int, CMQOObject*> m_object;
	map<string, CMQOObject*> m_objectname;

	map<int, CMQOMaterial*> m_ancmaterial;
	map<int, CMQOObject*> m_ancobject;
	map<int, CMQOObject*> m_boneobject;
	map<string, CBone*> m_bonename;

	map<int, CBone*> m_bonelist;

	int m_topbonenum;
	CBone* m_topbone;

	map<int, CInfScope*> m_infscope;


	WCHAR m_filename[MAX_PATH];
	WCHAR m_dirname[MAX_PATH];
};

#endif